<?php

namespace AustraliaPost\Extensions\Business\API\Wrapper;

use AustraliaPost\Extensions\Business\API\Wrapper\Connectors\Abstract_Connector;
use AustraliaPost\Helpers\Utilities;

class Shipment_Price {

	private $endpoint = '/prices/shipments';
	private $connector;
	private $response;
	/** @var Price_Request $shipmentPriceRequest */
	private $shipmentPriceRequest;

	/**
	 * Account constructor.
	 *
	 * @param Abstract_Connector $connector
	 * @param $shipmentPriceRequest
	 */

	public function __construct( $connector, $shipmentPriceRequest ) {
		$this->connector = $connector;
		$this->shipmentPriceRequest = $shipmentPriceRequest;
	}


	public function getItemPrices($groupByReference = false) {
		$this->response = $this->connector->connect(
			$this->endpoint,
			'POST',
			$this->getPayload()
		);

		if (isset($this->response['errors'])) {
			return $this->response;
		}

		$prices = [];

		$errors = $this->extractErrors();

		if (!is_array($this->response['shipments'])) {
			return $prices;
		}

		$prices = $this->response['shipments'];
		return $prices;
		$finalPrices = [];
		foreach ($prices as $item){
			$finalPrices =  array_merge($finalPrices, $item['shipment_summary']);
		}

		if (isset($this->response['warnings'])) {
			$finalPrices['warnings'] = $this->response['warnings'];
		}

		if (count($errors) > 0 ) {
			$finalPrices['errors'] = $errors;
		}

		return $finalPrices;
	}

	private function getPayload() {
		$pricePayload = $this->shipmentPriceRequest->getPayload();
		return Utilities::_json_encode($pricePayload);
	}

	private function extractErrors() {
		$errors = [];

		foreach($this->response['items'] as $item){
			if (!empty($item['errors'])) {
				foreach ($item['errors'] as $error) {
					$errors[] = $error;
				}
			}
		}
		return $errors;
	}


}


